<template>
  <div id="fluctuations">
    <div class="title-page">
        <div class="title">{{ $t('token_history.title') }}</div>
    </div>
    <template v-if="fluctuations.length > 0">
      <div class="wrapper-table">
        <table class="fluctuations">
          <thead>
            <tr>
              <th class="token">{{ $t('token_history.token_name') }}</th>
              <th>{{ $t('token_history.from') }}</th>
              <th class="note">{{ $t('token_history.notes') }}</th>
              <th>{{ $t('token_history.ending_balance') }}</th>
              <th>{{ $t('token_history.time') }}</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="fluctuation in fluctuations">
              <td class="token">{{ fluctuation.amount | formatCurrencyAmount('heta', 0) }}</td>
              <td class="action">{{ fluctuation.action_type }}</td>
              <td>{{ getNote(fluctuation) }}</td>
              <td>{{ fluctuation.ending_balance | formatCurrencyAmount('heta', 0) }}</td>
              <th>{{ formatDate(fluctuation) }}</th>
            </tr>
          </tbody>
        </table>
      </div>
    </template>
    <template v-else>
      <div class="wrapper-table">
        <table class="fluctuations">
          <thead>
            <tr>
              <th class="token">{{ $t('token_history.token_name') }}</th>
              <th>{{ $t('token_history.from') }}</th>
              <th class="note">{{ $t('token_history.notes') }}</th>
              <th>{{ $t('token_history.ending_balance') }}</th>
              <th>{{ $t('token_history.time') }}</th>
            </tr>
          </thead>
        </table>
      </div>
      <div class="not-found">
        <span class="iconmo-not-found not-found__icon"></span>
        <span class="not-found__text">{{ $t('token_history.not_found_text') }}</span>
      </div>
    </template>
  </div>
</template>
<script>
import { mapState } from 'vuex';
import moment from 'moment';

import rf from '../../common/requests/RequestFactory';

export default {
  data () {
    return {
      fluctuations: [],
    };
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
  methods: {
    async getTokenFluctuation () {
      if (this.user) {
        const res = await rf.getRequest('WalletRequest').getHetaFluctuations();
        console.log(res);
        this.fluctuations = [...res.data];
      }
    },
    formatDate (fluctuation) {
      return moment(fluctuation.created_at).format('YYYY-MM-DD HH:mm:ss');
    },
    getNote (fluctuation) {
      if (fluctuation.is_bounty) {
        return this.$t(`bounty.type.${fluctuation.object_type}`);
      };
      const currency = this.$options.filters.uppercase(fluctuation.object_type);
      const currencyAmount = this.$options.filters.formatCurrencyAmount(fluctuation.object, currency, 0);
      return `${currencyAmount} ${currency}`;
    },
  },
  watch: {
    user () {
      this.getTokenFluctuation();
    },
  },
  created () {
    this.$on('HetaBalanceFluctuated', () => {
      this.getTokenFluctuation();
    });
    this.getTokenFluctuation();
  },
};
</script>
<style lang="scss" scoped>
@import '../../../sass/app.scss';
  #fluctuations {
    width: 1130px;
    margin: 56px auto 0;
    font-family: 'Roboto';
    min-height: calc(100vh - 165px);
    .title-page {
      font-size: 0;

      .title {
        width: 60%;
        display: inline-block;
        font-size: 30px;
        font-weight: bold;
        color: #1c1c1c;
      }
    }
    .wrapper-table {
      width: 100%;
      position: relative;
      margin-top: 17px;
      padding-bottom: 50px;

      &:before {
        content: '';
        display: block;
        position: absolute;
        top: 0;
        left: 0;
        height: 50px;
        width: 100%;
        border-radius: 30px;
        background-color: #efefef;
        z-index: -1;
      }

      table.fluctuations {
        width: 100%;
        tr {
          height: 50px;
          td, th {
            font-family: 'Roboto';
            color: #1c1c1c;
            font-size: 14px;
            font-weight: normal;
            font-style: normal;
            font-stretch: normal;
            line-height: 3.57;
            letter-spacing: normal;
          }
          .token {
            padding-left: 30px;
          }
          .action {
            text-transform: capitalize;
          }
          .note {
            width: 24%;
          }
        }
        thead {
          tr {
            th {
              font-weight: bold;
              width: 19%;
              text-transform: capitalize !important;
            }
          }
        }
        tbody {
          tr {
            border-bottom: 1px solid #e0e0e0;
          }
        }
      }
    }

    .not-found {
      margin-top: 3px;
      text-align: center;
      .not-found__icon {
        padding: 25px;
        background-color: $bg_thin_gray;
        border-radius: 50%;
        font-size: 110px;
        display: inline-block;
        margin-bottom: 15px;
      }

      .not-found__text {
        display: block;
        font-size: 20px;
        color: $thin_gray;
      }
    }
  }

  @media screen and (max-width: 1200px) {
    #fluctuations {
      width: 100%;
      padding: 56px 20px 80px;
      margin-top: 0;
      .title {
        padding-top: 0;
      }
    }
  }
</style>
